/*
 * random.c - functions to get random values
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "defines.h"

/* global and extern variables */
extern u32 sum_z_cells;
extern int random_fd;

/* return random integer between 0 - max-1 */
u32 rand_get(u32 max) 
{
 u32 rand_int;
 if(read(random_fd,&rand_int,4)!=4)
 {
  puts("failed reading 4 bytes of random data");
  return -23;
 }
 /* cells numbered 0...max-1 */
 return((u32)(rand_int*(max*1.0/URAND_MAX)));
}

/* get z value (linear growth of probability with depths) */
u32 rand_get_lgp(int slope_nel,int start_nel) {
 int z;
 u32 i;
 z=rand_get(sum_z_cells)+1; /* +1 as rand_get returns values 0...max-1 */
 for(i=1;;i++) {
  z-=(start_nel+i*slope_nel);
  if(z<=0) break;
 }
 return(i-1); /* return values 0...z_cell-1 */
}


